import Router from '@koa/router';
export { default as Router } from '@koa/router';
import Koa from 'koa';
export { default as Koa } from 'koa';
import onFinished from 'on-finished';

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

class KoaApi extends Koa {
  constructor(options = {}) {
    var _options$attachBody;

    super(options.koa);
    this.router = void 0;
    this.firstRun = true;
    this.options = void 0;
    this.options = _extends({}, options, {
      attachBody: (_options$attachBody = options == null ? void 0 : options.attachBody) != null ? _options$attachBody : true
    });
    this.router = new Router(this.options.router);

    if (this.options.attachBody) {
      this.use(async function (ctx, next) {
        ctx.request.body = ctx.req.body;
        await next();
      });
    }
  }

  async run(req, res) {
    const p = new Promise(resolve => onFinished(res, resolve));

    if (this.firstRun) {
      this.firstRun = false;
      this.use(this.router.routes()).use(this.router.allowedMethods(this.options.routerAllowedMethods));
    }

    this.callback()(req, res);
    return p;
  }

}
function withKoaApi(koa) {
  return (req, res) => koa.run(req, res);
}

export { KoaApi, withKoaApi };
//# sourceMappingURL=index.modern.mjs.map
